"use strict";

// ## Задание

// Реализовать функцию, которая позволит оценить, успеет ли команда разработчиков сдать проект до наступления дедлайна. Задача должна быть реализована на языке javascript, без использования фреймворков и сторонник библиотек (типа Jquery).

// #### Технические требования:
// - Функция на вход принимает три параметра:
//   - массив из чисел, который представляет скорость работы разных членов команды. Количество элементов в массиве означает количество человек в команде. Каждый элемент означает сколько стори поинтов (условная оценка сложности выполнения задачи) может выполнить данный разработчик за 1 день.
//   - массив из чисел, который представляет собой беклог (список всех задач, которые необходимо выполнить). Количество элементов в массиве означает количество задач в беклоге. Каждое число в массиве означает количество стори поинтов, необходимых для выполнения данной задачи.
//   - дата дедлайна (объект типа Date).
// - После выполнения, функция должна посчитать, успеет ли команда разработчиков выполнить все задачи из беклога до наступления дедлайна (работа ведется начиная с сегодняшнего дня). Если да, вывести на экран сообщение: `Все задачи будут успешно выполнены за ? дней до наступления дедлайна!`. Подставить нужное число дней в текст. Если нет, вывести сообщение `Команде разработчиков придется потратить дополнительно ? часов после дедлайна, чтобы выполнить все задачи в беклоге`
// - Работа идет по 8 часов в день по будним дням

let speedWorkArr = [5, 7, 4, 7, 8, 7, 9]; //число-сколько может выполнить за разработчик 1 день.длина-кол-во работников.
let taskListArr = [75, 90, 55, 73, 49, 54]; //длина - кол-во задач. каждое число-сколько нужно стори поинтов, для выполнения данной задачи.

//let dateDeadLine = "2022-10-10";
let dateDeadLine = prompt(
  "Введите дату дедлайна в формате yyyy-mm-dd",
  "yyyy-mm-dd"
);

function estimateTime(speedWork, taskList, deadline) {
  let currentDate = new Date();
  let countDayMs = new Date(deadline) - currentDate;
  let countDay = Math.floor(((countDayMs / 3.6e6 / 24) * 100) / 100); // сколько всего дней между сегодня и дедлайном

  let plusDay = 0;
  let workDays = 0;
  for (let i = 0; i < countDay; i++) {
    currentDate.setDate(currentDate.getDate() + plusDay);
    plusDay++;

    if (currentDate.getDay() !== 0 && currentDate.getDay() !== 6) {
      workDays++;
    }
  }

  let allTasksCompletedInOneDay = speedWork.reduce(
    (accum, item) => accum + item
  );
  let allWorksPoints = taskList.reduce((accum, item) => accum + item);

  let needDays = 0;

  for (let i = 0; i < workDays; i++) {
    allWorksPoints -= allTasksCompletedInOneDay;
    if (allWorksPoints <= 0) {
      break;
    } else {
      needDays++;
    }
  }
  if (allWorksPoints <= 0) {
    alert(
      `Все задачи будут успешно выполнены за ${workDays - needDays} дней до наступления дедлайна!`
    );
  } else {
    let notDone = allWorksPoints / allTasksCompletedInOneDay;
    alert(
      `Команде разработчиков придется потратить дополнительно ${Math.floor((notDone * 8 * 100) / 100)} часов после дедлайна, чтобы выполнить все задачи в беклоге`
    );
  }
}
estimateTime(speedWorkArr, taskListArr, dateDeadLine);
